unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls, Perlin;

type
  TPixel = array [1..3] of Byte;

  TForm1 = class(TForm)
    PaintBox1: TPaintBox;
    Button1: TButton;
    RadioGroup1: TRadioGroup;
    ScrollBar1: TScrollBar;
    Label1: TLabel;
    ScrollBar2: TScrollBar;
    Label2: TLabel;
    Edit1: TEdit;
    Label3: TLabel;
    CheckBox1: TCheckBox;
    ComboBox1: TComboBox;
    Label4: TLabel;
    RadioGroup2: TRadioGroup;
    Button2: TButton;
    RadioGroup3: TRadioGroup;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure ScrollBar2Change(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  Bitmap: TBitmap;
  Noise: TPerlinNoise2D;

implementation

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
begin
  Randomize;

  Bitmap := TBitmap.Create;
  Bitmap.Width := 256;
  Bitmap.Height := 256;
  Bitmap.PixelFormat := pf24bit;

  Noise := TPerlinNoise2D.Create;
  Noise.Persistence := 0.6;
  Noise.Seed := 12345;
  Noise.Depth := 8;
  Noise.SetAmplitude(0, 255);
  Noise.Frequency := 0.01;
  Noise.FrequencyFactor := 2;
  Noise.Size := 256;

  Noise.SetValues;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  Bitmap.Free;
  Noise.Free;
end;

procedure TForm1.Button1Click(Sender: TObject);
var
  i, j: integer;
  p: ^TPixel;
  Value : Byte;
begin
  if ComboBox1.ItemIndex <> -1 then
  begin
    Noise.Depth := ScrollBar2.Position;
    Noise.RandomMode := TRandomMode(RadioGroup3.ItemIndex);
    if CheckBox1.Checked then
      Edit1.Text := inttostr(Random($FFFF));
    Noise.Seed := strtoint(Edit1.Text);
    Noise.Calculate;
    if ComboBox1.ItemIndex = 0 then
    begin
      for i := 0 to 255 do
      begin
        p := Bitmap.ScanLine[i];
        for j := 0 to 255 do
        begin
          Value := Round(Noise.GetValue(i,j));
          p^[1] := Value;
          p^[2] := Value;
          p^[3] := Value;
          inc(p);
        end;
      end;
    end
    else
    begin
      for i := 0 to 255 do
      begin
        p := Bitmap.ScanLine[i];
        for j := 0 to 255 do
        begin
          Value := Round(Noise.GetValue(i,j,ComboBox1.ItemIndex -1));
          p^[1] := Value;
          p^[2] := Value;
          p^[3] := Value;
          inc(p);
        end;
      end;
    end;
  end;

  PaintBox1.Canvas.Draw(0,0,Bitmap);
end;

procedure TForm1.ScrollBar2Change(Sender: TObject);
var
  i: integer;
  OldValue: integer;
begin
  OldValue := ComboBox1.ItemIndex;
  ComboBox1.Clear;
  ComboBox1.Items.Add('All Layers');
  for i := 0 to ScrollBar2.Position -1 do
    ComboBox1.Items.Add('Layer '+inttostr(i));

  Label2.Caption := 'Oktaven: '+inttostr(ScrollBar2.Position);

  ComboBox1.ItemIndex := ComboBox1.Items.Count -1;
  if OldValue <= ComboBox1.Items.Count then ComboBox1.ItemIndex := OldValue;
end;

end.
